/*
 *  $Id: subr.c,v 1.2 1999/07/13 07:21:37 ezk Exp $
 */

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif /* HAVE_CONFIG_H */
#include <fist.h>
#include <rot13fs.h>

/*
 * add 1 to each byte
 * return the number of bytes written
 */
int
rot13fs_encode_block(const char *inbuf, char *outbuf, int len)
{
    unsigned char *incp = (unsigned char *) inbuf;
    unsigned char *outcp = (unsigned char *) outbuf;
    unsigned char c;
    int i;

    for (i = 0; i < len; i++) {
	c = *incp & ~0x20;		/* uppercase c */
	if (c < 'A' || c > 'Z') {
	    incp++;
	    outcp++;
	    continue;
	}
	if (c > 'M')
	    *outcp -= 13;
	else
	    *outcp += 13;
	incp++;
	outcp++;
    }
    return len;
}


/*
 * subtract 1 from each byte
 * return the number of bytes written
 */
int
rot13fs_decode_block(const char *inbuf, char *outbuf, int len)
{
    /* rot13 decode and encode are identical */
    return rot13fs_encode_block(inbuf, outbuf, len);
}

/*
 * Local variables:
 * c-basic-offset: 4
 * End:
 */
